#include <genstub.c>
#include <winnls.h>

// Define code pages typically available.
typedef struct CPListElementtag {
    UINT uCPId;
    char szCPName[40];
} CPListElement;

CPListElement codepages [50] = {
                        037, "EBCDIC",
                        437, "MS-DOS United States",
                        500, "EBCDIC 500V1",
                        708, "Arabic (ASMO 708)",
                        709, "Arabic (ASMO 449+, BCON V4)",
                        710, "Arabic (Transparent Arabic)",
                        720, "Arabic (Transparent ASMO)",
                        737, "Greek (formerly 437G)",
                        775, "Baltic",
                        850, "MS-DOS Multilingual (Latin I)",
                        852, "MS-DOS Slavic (Latin II)",
                        855, "IBM Cyrillic (primarily Russian)",
                        857, "IBM Turkish",
                        860, "MS-DOS Portuguese",
                        861, "MS-DOS Icelandic",
                        862, "Hebrew",
                        863, "MS-DOS Canadian-French",
                        864, "Arabic",
                        865, "MS-DOS Nordic",
                        866, "MS-DOS Russian",
                        869, "IBM Modern Greek",
                        874, "Thai",
                        875, "EBCDIC",
                        932, "Japan",
                        936, "Chinese (PRC, Singapore)",
                        949, "Korean",
                        950, "Chinese (Taiwan, Hong Kong) ",
                       1026, "EBCDIC",
                       1200, "Unicode (BMP of ISO 10646)",
                       1250, "Windows 3.1 Eastern European ",
                       1251, "Windows 3.1 Cyrillic",
                       1252, "Windows 3.1 US (ANSI)",
                       1253, "Windows 3.1 Greek",
                       1254, "Windows 3.1 Turkish",
                       1255, "Hebrew",
                       1256, "Arabic",
                       1257, "Baltic",
                       1361, "Korean (Johab)",
                      10000, "Macintosh Roman",
                      10001, "Macintosh Japanese",
                      10006, "Macintosh Greek I",
                      10007, "Macintosh Cyrillic",
                      10029, "Macintosh Latin 2",
                      10079, "Macintosh Icelandic",
                      10081, "Macintosh Turkish",
                          0 ,"Undefined"
                    };

BOOL CALLBACK EnumCodePages( LPWSTR lpCPString )
{
    TCHAR  szBuffer[128];
    DWORD  wCodePage;
    CPINFO cpInfo;
    int i = 0;

    // Convert to ANSI to parse with C functions.
    WideCharToMultiByte( CP_ACP, 0, lpCPString, -1, szBuffer, 127, NULL, NULL );

    wsprintf( szBuffer, "%s", lpCPString);
    sscanf( szBuffer, "%u", &wCodePage );

    while ( (codepages[i].uCPId != 0) && (codepages[i].uCPId != wCodePage ) )
        i++;

    wsprintf( szBuffer, "Code Page = %d, Name = %s", wCodePage,
              codepages[i].szCPName );

    if ( IsValidCodePage( wCodePage ) )
    {
       char szMore[32];
       GetCPInfo( wCodePage, &cpInfo );
       wsprintf( szMore, " Max Char Width: %d", cpInfo.MaxCharSize );
       lstrcat( szBuffer, szMore );
    }
    else
       lstrcat( szBuffer, " Invalid Code Page" );

    MessageBox( NULL, szBuffer, "Code Page Enumeration", MB_OK );
    return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static BOOL bFlag = CP_INSTALLED;
    switch (uMsg)
    {
            case WM_COMMAND:       /* process menu items */
                    switch ( LOWORD( wParam )  )
                    {
                        case IDM_TEST:  // clear window and display screen.
                              EnumSystemCodePages( EnumCodePages, CP_INSTALLED );
                              break;
                        case IDM_EXIT:
                              DestroyWindow( hWnd );
                              break;
                    }
                    break;
            case WM_DESTROY:
                    PostQuitMessage( 0 );
                    break;
           default:
                 return (DefWindowProc(hWnd, uMsg, wParam, lParam));
    }
    return (NULL);
}